package com.zt.plat.module.qms.resource.device.service;

import java.util.*;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.zt.plat.framework.common.pojo.CommonResult;
import com.zt.plat.module.qms.resource.device.controller.vo.*;
import com.zt.plat.module.qms.resource.device.dal.dataobject.DevicePeriodCheckDO;
import com.zt.plat.module.qms.resource.device.dal.dataobject.DevicePeriodCheckPlanDO;
import jakarta.validation.*;
import com.zt.plat.framework.common.pojo.PageResult;

/**
 * 设备-期间核查 Service 接口
 *
 * @author 后台管理-1
 */
public interface DevicePeriodCheckService {


    void createListByPlanDevice(DevicePeriodCheckPlanDO plan);

    void createListByPlanMaterial(DevicePeriodCheckPlanDO plan);

    CommonResult<List<DevicePeriodCheckVO>> getLastDataCheckList(List<Long> deviceIds, String flowStatus);

    IPage<DevicePeriodCheckVO> queryPageListDevice(Page<DevicePeriodCheckPageReqVO> page, DevicePeriodCheckPageReqVO pageReqVO);
    IPage<DevicePeriodCheckVO> queryPageListMaterial(Page<DevicePeriodCheckPageReqVO> page, DevicePeriodCheckPageReqVO pageReqVO);

    void updateEffectiveFlag(Long planId, String effectiveFlag);

    List<DevicePeriodCheckDO> getListByPlanId(Long planId);

    CommonResult<DevicePeriodCheckRespVO> submitApply(DevicePeriodCheckSaveReqVO paramVO);
    
    /**
     * 创建设备-期间核查
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    DevicePeriodCheckRespVO createDevicePeriodCheck(@Valid DevicePeriodCheckSaveReqVO createReqVO);

    DevicePeriodCheckRespVO createByDeviceId(DevicePeriodCheckSaveReqVO createReqVO);

    DevicePeriodCheckRespVO createByMaterialId(DevicePeriodCheckSaveReqVO createReqVO);

    /**
     * 更新设备-期间核查
     *
     * @param updateReqVO 更新信息
     */
    DevicePeriodCheckDO updateDevicePeriodCheck(@Valid DevicePeriodCheckSaveReqVO updateReqVO);

    /**
     * 删除设备-期间核查
     *
     * @param id 编号
     */
    void deleteDevicePeriodCheck(Long id);

    /**
    * 批量删除设备-期间核查
    *
    * @param ids 编号
    */
    void deleteDevicePeriodCheckListByIds(List<Long> ids);

    /**
     * 获得设备-期间核查
     *
     * @param id 编号
     * @return 设备-期间核查
     */
    DevicePeriodCheckDO getDevicePeriodCheck(Long id);

    DevicePeriodCheckVO getVoDevice(Long id);
    DevicePeriodCheckVO getVoMaterial(Long id);
    DevicePeriodCheckVO getLastDataMaterial(JSONObject param);
    DevicePeriodCheckVO getLastDataDevice(JSONObject param);
    /**
     * 获得设备-期间核查分页
     *
     * @param pageReqVO 分页查询
     * @return 设备-期间核查分页
     */
    PageResult<DevicePeriodCheckDO> getDevicePeriodCheckPage(DevicePeriodCheckPageReqVO pageReqVO);

    void updateBatch(List<DevicePeriodCheckDO> list);

    void insertBatch(List<DevicePeriodCheckDO> list);
}